﻿Imports System.IO
Imports System.Net.Http
Imports System.Net.Http.Headers
Imports System.Text
Imports Newtonsoft.Json

Public Class Form1




    Private Async Sub BtnRecuperaMensajes_Click(sender As Object, e As EventArgs) Handles btnRecuperaMensajes.Click
        Dim httpClient As New HttpClient()

        Dim urlToPost As String

        Try
            'URL para hacer la petición de recuperar mensajes, siempre devuelve de 100 en 100.
            urlToPost = "https://whatzmeapi.com:10501/rest/api/mensajes?token=" & token.Text

            'Si ultimoMensaje esta vacio, quiere decir que voy a devolver los primeros 100 mensajes
            If txtUltimoMensaje.Text <> "" Then
                urlToPost = urlToPost + "&ultimoMensaje=" & txtUltimoMensaje.Text
            End If

            'Obtiene la respuesta de la petición en formato JSON
            Dim response As String = Await httpClient.GetStringAsync(urlToPost)

            respuesta.Text = response 'Esto regresa la respuesta en formato JSON

            'Opcionalmente si quieres recuperar los mensajes como objetos VB.NET se sugiere agregar la libreria (NuGet) de Newtonsoft a tu proyecto
            'Revisar la clase en el namespace Model, esa clase se genero en https://jsonutils.com/ a partir del JSON de respuesta.
            Dim objMensajes As MensajesRespuesta = JsonConvert.DeserializeObject(Of MensajesRespuesta)(response)
            MessageBox.Show("Ultimo mensaje recuperado: " & objMensajes.ultimoMensaje) 'Regresa paginados los mensajes de 100 en 100

            'Para ver el detalle de los mensajes recorrer objMensajes.mensajes y ver el contenido de cada mensaje con la clase Mensaje del namespace Model 
            'For Each mensaje As Mensaje In objMensajes.mensajes
            'MessageBox.Show(mensaje.texto & " " & mensaje.esDeSalida & " " + mensaje.nombreChat)
            'Next
            lstMensajes.DataSource = objMensajes.mensajes


        Catch ex As Exception
            respuesta.Text = ex.Message
        End Try
    End Sub

    Private Async Sub btnEnviarMensaje_Click(sender As Object, e As EventArgs) Handles btnEnviarMensaje.Click
        respuesta.Text = ""
        If String.IsNullOrEmpty(token.Text) Then
            MsgBox("El token es requerido para continuar")
            Return
        End If
        Dim httpClient As New HttpClient()

        Dim resString As String

        Dim urlToPost As String

        Try
            'URL para hacer la petición de enviar mensaje.
            urlToPost = "https://whatzmeapi.com:10501/rest/api/enviar-mensaje?token=" & token.Text
            httpClient.DefaultRequestHeaders.Accept.Add(New MediaTypeWithQualityHeaderValue("application/json"))
            'Número de destino y mensaje a enviar, si se ocupa el componente NewtonSoft este código se puede optimizar
            resString = "{""numero"" : """ & numero.Text & """,""mensaje"" : """ & mensaje.Text & """}"

            'Obtiene la respuesta de la petición en formato JSON
            Dim response As HttpResponseMessage = Await httpClient.PostAsync(urlToPost, New StringContent(resString, Encoding.UTF8, "application/json"))
            respuesta.Text = Await response.Content.ReadAsStringAsync()

        Catch ex As Exception
            respuesta.Text = ex.Message
        End Try
    End Sub

    Private Async Sub btnEnviarArchivo_Click(sender As Object, e As EventArgs) Handles btnEnviarArchivo.Click
        respuesta.Text = ""
        If String.IsNullOrEmpty(token.Text) Then
            MsgBox("El token es requerido para continuar")
            Return
        End If
        Dim httpClient As New HttpClient()

        Dim resString As String

        Dim urlToPost As String

        Try
            'URL para hacer la petición de enviar mensaje.
            urlToPost = "https://whatzmeapi.com:10501/rest/api/enviar-archivo?token=" & token.Text
            httpClient.DefaultRequestHeaders.Accept.Add(New MediaTypeWithQualityHeaderValue("application/json"))

            Dim nombrearchivo = txtnombrearchivo.Text 'Este es el nombre con el que el archivo se va a guardar en el dipositivo destino 

            'Convertimos la ruta local a Base 64 y agregamos el mime type
            If Not System.IO.File.Exists(ruta.Text) Then
                MsgBox("El archivo a enviar no existe")
                Return
            End If


            Dim filebase64 = Convert.ToBase64String(System.IO.File.ReadAllBytes(ruta.Text)) 'Esta es la ruta local del archivo en formato Base 64

            filebase64 = "data:" & MimeTypeUtil.GetFromFileName(ruta.Text) & ";base64," & filebase64


            'Número de destino y mensaje a enviar, si se ocupa el componente NewtonSoft este código se puede optimizar
            resString = "{""numero"" : """ & numeroarchivo.Text & """,""nombrearchivo"" : """ & nombrearchivo & """,""url"" : """ & filebase64 & """,""textoimagen"" : """ & mensajearchivo.Text & """}"

            'Obtiene la respuesta de la petición en formato JSON
            Dim response As HttpResponseMessage = Await httpClient.PostAsync(urlToPost, New StringContent(resString, Encoding.UTF8, "application/json"))
            respuesta.Text = Await response.Content.ReadAsStringAsync()

        Catch ex As Exception
            respuesta.Text = ex.Message
        End Try
    End Sub


End Class
